<?xml version="1.0"  encoding="UTF-8"?>
<!--
    Inspired by Stylesheet written by Kurt Cagle  (Code from Professional XSL, Chapter 14, Wrox press, Spring 2001).
    See : http://www.zvon.org/HowTo/Output/howto_jj_svg_23.html
-->
<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
   <!--
    <xsl:template match="test">
  	Use this xml stream to unit test:
    	$ echo '<?xml version="1.0"  encoding="UTF-8"?><test value="D:\toto\tat\unix/file"/>' > test.xml
    	$ xsltproc src/main/stylesheets/util/api/filenameToUnix.xsl test.xml
     
		<xsl:variable name="url"><xsl:value-of select="@value"/></xsl:variable>    
		<xsl:message>Before: <xsl:value-of select="$url"/></xsl:message>
		<xsl:variable name="post-url">
			<xsl:call-template name="filename2unix">
				<xsl:with-param name="url">
					<xsl:value-of select="$url"/>
				</xsl:with-param>
			</xsl:call-template>
		</xsl:variable>
		<xsl:message>After: <xsl:value-of select="$post-url"/></xsl:message>	
    </xsl:template>
    -->

    <xsl:template name="filename2win">
		<xsl:param name="url"/>
		<xsl:variable name="backslash"	select="'\'"/>
		<!--  Replacing \ by / -->
		<xsl:variable name="url-without-backslashes">
			<xsl:call-template name="replace-all">
				<xsl:with-param name="url">
					<xsl:value-of select="$url"/>
				</xsl:with-param>
				<xsl:with-param name="replaceWith">
					<xsl:value-of select="'\'"/>
				</xsl:with-param>
				<xsl:with-param name="toReplace">
					<xsl:value-of select="'/'"/>
				</xsl:with-param>
			</xsl:call-template>
		</xsl:variable>
		<xsl:value-of select="$url-without-backslashes"/>
	</xsl:template>

    <xsl:template name="filename2unix">
		<xsl:param name="url"/>
		<xsl:variable name="slash"	select="'/'"/>
		<!--  Replacing \ by / -->
		<xsl:variable name="url-without-backslashes">
			<xsl:call-template name="replace-all">
				<xsl:with-param name="url">
					<xsl:value-of select="$url"/>
				</xsl:with-param>
				<xsl:with-param name="replaceWith">
					<xsl:value-of select="'/'"/>
				</xsl:with-param>
				<xsl:with-param name="toReplace">
					<xsl:value-of select="'\'"/>
				</xsl:with-param>
			</xsl:call-template>
		</xsl:variable>
		<!-- Cleaning the root -->
		<xsl:value-of select="concat($slash,substring-after($url-without-backslashes,$slash))"/>
	</xsl:template>
    
    
    
    <xsl:template name="replace-all">
        <xsl:param name="url"/>
        <xsl:param name="toReplace"/>
        <xsl:param name="replaceWith"/>
        <!-- 
        <xsl:message>
        	Replace-all called with: Subj:[ <xsl:value-of select="$url"/> ], <xsl:value-of select="$toReplace"/> -> <xsl:value-of select="$replaceWith"/>
        </xsl:message>
         -->
        <xsl:choose>
        	<xsl:when test="contains($url,$toReplace)">
            	<xsl:variable name="pre" select="concat(substring-before($url,$toReplace),$replaceWith)" />
                <xsl:variable name="post" select="substring-after($url,$toReplace)" /><!-- 
                <xsl:message>
                	tmp:<xsl:value-of select="concat($pre,$post)"/>
                </xsl:message> -->
                <xsl:call-template name="replace-all">
                	<xsl:with-param name="url"			select="concat($pre,$post)"/>
                	<xsl:with-param name="replaceWith"	select="$replaceWith"/>
					<xsl:with-param name="toReplace"	select="$toReplace"/>
                </xsl:call-template>
			</xsl:when>
            <xsl:otherwise><!-- 
            	<xsl:message>End of recursion:<xsl:value-of select="$url"/></xsl:message> -->
            	<xsl:value-of select="$url"/>
            </xsl:otherwise>
        </xsl:choose>
	</xsl:template>
    
    
</xsl:stylesheet>    