<?xml version="1.0"  encoding="UTF-8"?>
<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:math="http://exslt.org/math"
                extension-element-prefixes="math">

<xsl:import href="math.sine.template.xsl"/>

<!-- Input parameter must be a rad -->
<xsl:template name="math:cosine">
  <xsl:param name="base" select="0" />
  <xsl:choose>
      <xsl:when test="$base &lt; - 2 * $math:pi or $base &gt; 2 * $math:pi">
      <xsl:message terminate="yes">
        The XSLT template math:sine doesn't support
        arguments with absolute value over 4 PI.
      </xsl:message>
      <xsl:text>NaN</xsl:text>
    </xsl:when>
    <xsl:otherwise>
      <xsl:call-template name="math:sine">
        <xsl:with-param name="base" select="$math:pi div 2 - $base"/>
      </xsl:call-template>
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>


</xsl:stylesheet>
